#!/bin/sh
# detect "modesetting" and apply SWCursor to xorg.conf

DRV=$(report-video -d)
echo ${DRV}
[ "$DRV" = "intel" ]|| exit
    
[ -f /etc/cedar ]&& exit #run once only

apply_swcursor() {
	cp /etc/X11/xorg.conf /tmp/xorg.conf.new
	SWCURSOR=$(grep -iE "swcursor" /etc/X11/xorg.conf) #Returns <--		#Option     "SWcursor"           	# [<bool>]
	[ "$SWCURSOR" ] || echo "" > /etc/cedar || exit #exit if non-existant, ensure it doesn't run again
#	cat /etc/X11/xorg.conf | sed "s%$SWCURSOR%	Option     \"SWcursor\"           	# [<bool>]%" > /etc/X11/xorg.conf.new
	sed 's/#Option     "SWcursor"/Option     "SWcursor"/'  </etc/X11/xorg.conf >/etc/X11/xorg.conf.new 2>/dev/null
	mv -f /etc/X11/xorg.conf.new /etc/X11/xorg.conf
	BACKUP=$(cat /etc/X11/xorg.conf|tail -1|cut -d '=' -f2)
	cp -af /etc/X11/xorg.conf /etc/X11/xorg.conf.${BACKUP}
	echo "" > /etc/cedar
	sleep 1
	restartwm
}

export gui='<window title="'$DRV'">
  <vbox>
    <text><label>It seems you are running the '$DRV' Xorg video driver and it is possible that your mouse cursor is not working properly or looks like a large square block. If this is the case just press Enter on your keyboard and the graphical X server will restart, if not just dismiss this window.</label></text>
    <hbox><button ok></button><button cancel></button>
    </hbox>
  </vbox>
</window>'
eval $(gtkdialog -p gui -c)
echo $EXIT
case $EXIT in
OK)apply_swcursor
;;
*)echo "" > /etc/cedar # produce on dismissal, assume cursor is ok
exit
;;
esac
